/*
 * klavesnice k alarmu
 * pic 16F627A
 */

#include	<pic.h>
__CONFIG   (UNPROTECT&UNPROTECT&LVPDIS&BOREN&MCLREN&PWRTEN&WDTDIS&INTIO);

#include	<stdio.h>
#include	"delay.h"


#define bitset(var,bitno) ((var)|= 1<<(bitno))
#define bitclr(var,bitno) ((var)&=~(1<<(bitno)))
#define PORTBIT(adr, bit)       ((unsigned)(&adr)*8+(bit))
static bit      RB0 @ PORTBIT(PORTB, 0);  //pripojeni klavesnice 
static bit      RB1 @ PORTBIT(PORTB, 1);
static bit      RB2 @ PORTBIT(PORTB, 2);
static bit      RB3 @ PORTBIT(PORTB, 3);  //v pripade mensi klavesnice 3 x 4 tlacitek neni vyuzito
static bit      HS @ PORTBIT(PORTB, 4);  
static bit      RB5 @ PORTBIT(PORTB, 5);  
static bit      RB6 @ PORTBIT(PORTB, 6);  
static bit      RB7 @ PORTBIT(PORTB, 7); 

static bit      LEDR @ PORTBIT(PORTA, 3);  
static bit      LEDG @ PORTBIT(PORTA, 2); 
static bit      RELE @ PORTBIT(PORTA, 1);  
static bit      PIEZO @ PORTBIT(PORTA, 0); 

unsigned char a=255;
unsigned char i=0;
unsigned char tmp_a=0;
unsigned char code[4]={0,0,0,0};                 	//4 prvkove pole pro ulozeni kodu
unsigned char code_new[4]={0,0,0,0};             //4 prvkove pole pro ulozeni noveho kodu
unsigned char code_new_tmp[4]={0,0,0,0};        	//4 prvkove pole pro ulozeni zalohy noveho kodu
unsigned char key_cnt=0;				//pocitadlo stisku klaves
unsigned char key_cnt1=0;				//pocitadlo stisku klaves u noveho kodu
unsigned char code_ok_cnt=0;			//pocitadlo spravnych cislic kodu
unsigned char err=0;					//priznak chybneho kodu
unsigned char change_code=0;     		//priznak zmeny kodu (stisknuto spravny kod + *
unsigned int  key_timer=0;  			//odpocitavani doby pro zadani kodu
unsigned char err_cnt=0;				//pocitadlo chybnych kodu nebo vyprseni casovych limitu
//------------------------------------------------------------------
void Beep ()
{
PIEZO=1;
DelayMs(50);
PIEZO=0;
}

//------------------------------------------------------------------
main(void)
{
							 //celkova inicializace
   CMCON = 0x07;		 	 // komparatory vypnuty (pro 16F62x)
   TRISA = 0b00000000;       // vse vystupy
   TRISB = 0b00000000;       // vse vystupy
   PORTA = 0;
   PORTB = 0;
   GIE=0;   
   
   OPTION, T0CS = 0;		//hodinovy signal pro TMR0, 1-RA4/TCKI, 0-fosc/4
   OPTION, T0SE = 0;		//volba hrany hod signalu TMR0, zvysena na 1-sestupnou, 0-vzestupnou na vyvodu RA4/T0CKI
   OPTION, PSA = 0;			//prirazeni preddelice, 1-WDG, 0-TMR0
   OPTION, PS2 = 1; 		//
   OPTION, PS1 = 1;			//bity nastavujici delici pomer preddelice ()
   OPTION, PS0 = 1;			//

//nastaveni INTCON
   INTCON,GIE = 0;			//vsechna preruseni, 1-povoleny, 0-zakazany
   INTCON,PEIE = 0;			//preruseni periferii, 1-nastavena preruseni povolena, 0-nastavena preruseni zakazana
   INTCON,T0IE = 0;         //povoleni preruseni pri preteceni TMR0, 1-povoleno, 0-zakazano
   INTCON,INTE = 0;			//povoleni preruseni od udalosti na RB0/INT, 1-povoleno, 0-zakazano
   INTCON,RBIE = 0;			//povoleni preruseni od zmeny stavu na RB<7:4>, 1-povoleno, 0-zakazano
   INTCON,T0IF = 0;			//priznak preruseni od preteceno TMR0, 1-pretekl, 0-nepretekl
   INTCON,INTF = 0;			//priznak preruseni od udalosti na vyvodu RB0/INT,  1-doslo k nastavene udalosti na RB0 (vzest./sest. hrana), 0-nedoslo k udalosti
        
   
while(1==1)  
{
   HS=0;
   DelayS(1);
   HS=1;
   DelayS(1);
}   
   
   

}
static void interrupt
isr(void)
{
if (T0IF==1)
  {
  T0IF=0;									//nulovani priznaku preruseni
  
  }

}
